// SuperScalingDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SuperScaling.h"
#include "SuperScalingDlg.h"
#include "Fast2PassScale.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const int      ORIGINAL_WIDTH  = 200;
const int      ORIGINAL_HEIGHT = 100;
const int      SCALED_WIDTH    = 100;
const int      SCALED_HEIGHT   = 50;
const int      BORDER          = 20;

const int      BITMAP_PLANES   = 1;
const int      BITMAP_BITDEPTH = 32;

const int      FONT_WIDTH      = 30;
const int      FONT_HEIGHT     = 15;

const char     FONT_NAME[]     = "Arial";

const COLORREF BACKGROUND      = 0xFFFFFF;
const COLORREF FOREGROUND      = 0x000000;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSuperScalingDlg dialog

CSuperScalingDlg::CSuperScalingDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSuperScalingDlg::IDD, pParent), m_OriginalBitmap(NULL),
	  m_ScaledBitmap(NULL), m_OriginalBitmapBits(NULL), m_ScaledBitmapBits(NULL)
{
	//{{AFX_DATA_INIT(CSuperScalingDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

CSuperScalingDlg::~CSuperScalingDlg()   // Delete the Dibsections
{

	if ( m_OriginalBitmap != NULL )
		VERIFY(DeleteObject(m_OriginalBitmap) != FALSE);
	if ( m_ScaledBitmap != NULL )
		VERIFY(DeleteObject(m_ScaledBitmap) != FALSE);

}
void CSuperScalingDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSuperScalingDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSuperScalingDlg, CDialog)
	//{{AFX_MSG_MAP(CSuperScalingDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSuperScalingDlg message handlers

BOOL CSuperScalingDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	BuildBitmaps();            // Create the bitmaps
	CreateOriginalImage();     // Create the original image
	CreateScaledImage();       // Scale the original image.

	return TRUE;  // return TRUE  unless you set the focus to a control
}
void CSuperScalingDlg::CreateScaledImage()
{
    
    CFast2PassScale ScaleEngine;                  // Create an instance of the scaling class
    
    ScaleEngine.Scale(   m_OriginalBitmapBits,    // Scale!
                          ORIGINAL_WIDTH,
                          ORIGINAL_HEIGHT,
					      m_ScaledBitmapBits,
                          SCALED_WIDTH,
                          SCALED_HEIGHT);

}
void CSuperScalingDlg::CreateOriginalImage()
{

	CPaintDC dc(this); 
	CDC OriginalDC;
	VERIFY(OriginalDC.CreateCompatibleDC(&dc) != FALSE);                           // Create a DC

	HBITMAP pOldBitmap = (HBITMAP)OriginalDC.SelectObject(m_OriginalBitmap);       // Select the original bitmap

	OriginalDC.FillSolidRect( 0, 0, ORIGINAL_WIDTH, ORIGINAL_HEIGHT, BACKGROUND);  // Fill in a background color

	CRect FontRect(0, 0, ORIGINAL_WIDTH, ORIGINAL_HEIGHT);                         // A rectangle for the printing

	CFont TheFont;                                                                 // Create a font object
	TheFont.CreateFont( FONT_WIDTH, FONT_HEIGHT, 0, 0, FW_MEDIUM, true, 0, 0, 0, OUT_TT_PRECIS, CLIP_TT_ALWAYS, PROOF_QUALITY  , FF_DONTCARE, FONT_NAME );
    CFont* pOldFont = OriginalDC.SelectObject(&TheFont);                           // Select the font object

	VERIFY(OriginalDC.DrawText("Hello World!\nScale me!!!", &FontRect, DT_NOCLIP ) // Draw a string in the selected font onto the Original bitmap
		   != NULL);

	OriginalDC.SelectObject(pOldFont);     // Select the old font and 
	OriginalDC.SelectObject(pOldBitmap);   // old bitmaps back into the DC

}
void CSuperScalingDlg::BuildBitmaps()
{


	void* BitmapBitsPtr;

	// Create the original bitmap...

	BITMAPINFO OriginalBitmapInfo;
	memset(&OriginalBitmapInfo, NULL, sizeof(BITMAPINFO));   // Clear out the structure

	OriginalBitmapInfo.bmiHeader.biSize     = sizeof(BITMAPINFOHEADER);
	OriginalBitmapInfo.bmiHeader.biWidth    = ORIGINAL_WIDTH;
	OriginalBitmapInfo.bmiHeader.biHeight   = ORIGINAL_HEIGHT;
	OriginalBitmapInfo.bmiHeader.biPlanes   = BITMAP_PLANES;
	OriginalBitmapInfo.bmiHeader.biBitCount = BITMAP_BITDEPTH;
   
	m_OriginalBitmap = CreateDIBSection( NULL, &OriginalBitmapInfo, DIB_RGB_COLORS, &BitmapBitsPtr, NULL, NULL);
	VERIFY(m_OriginalBitmap != NULL);

	m_OriginalBitmapBits = (unsigned long*)BitmapBitsPtr;

	// Create a bitmap for holding the scaled bitmap information

	BITMAPINFO ScaledBitmapInfo;
	memset(&ScaledBitmapInfo, NULL, sizeof(BITMAPINFO));   // Clear out the structure

	ScaledBitmapInfo.bmiHeader.biSize     = sizeof(BITMAPINFOHEADER);
	ScaledBitmapInfo.bmiHeader.biWidth    = SCALED_WIDTH;
	ScaledBitmapInfo.bmiHeader.biHeight   = SCALED_HEIGHT;
	ScaledBitmapInfo.bmiHeader.biPlanes   = BITMAP_PLANES;
	ScaledBitmapInfo.bmiHeader.biBitCount = BITMAP_BITDEPTH;

	m_ScaledBitmap = CreateDIBSection( NULL, &ScaledBitmapInfo, DIB_RGB_COLORS, &BitmapBitsPtr, NULL, NULL);
	VERIFY(m_ScaledBitmap != NULL);

	m_ScaledBitmapBits = (unsigned long*)BitmapBitsPtr;


}
void CSuperScalingDlg::PaintBitmaps()
{
	CPaintDC dc(this); // device context
	CDC SoftwareDC;
	VERIFY(SoftwareDC.CreateCompatibleDC(&dc) != FALSE);                            // Create a DC
	HBITMAP pOldBitmap = (HBITMAP)SoftwareDC.SelectObject(m_OriginalBitmap);        // Select the Original bitmap
	dc.BitBlt(BORDER, 0, ORIGINAL_WIDTH, ORIGINAL_HEIGHT,&SoftwareDC,0,0,SRCCOPY);  // Blit the original bitmap to hardware

	SoftwareDC.SelectObject(m_ScaledBitmap);                                        // Now select the scaled bitmap into the DC
	dc.BitBlt(BORDER, ORIGINAL_HEIGHT + BORDER, SCALED_WIDTH, SCALED_HEIGHT,        // Blit the scaled bitmap to hardware 
		      &SoftwareDC,0,0,SRCCOPY);

	SoftwareDC.SelectObject(pOldBitmap);                                            // Select the old bitmap back into the DC
}

void CSuperScalingDlg::OnPaint() 
{

	PaintBitmaps();     // Call our Paint bitmaps function
	CDialog::OnPaint();
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSuperScalingDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
